;==========================================================================
;		 MPASM (Microchip)
;==========================================================================

INDF0		EQU	000H
FSR0		EQU	001H
PCL		EQU	002H
PCLATH		EQU	003H
ALUSTA		EQU	004H

;	ALUSTA bits:
#DEFINE	C	ALUSTA,0
#DEFINE	DC	ALUSTA,1
#DEFINE	Z	ALUSTA,2
#DEFINE	OV	ALUSTA,3
#DEFINE	FS0	ALUSTA,4
#DEFINE	FS1	ALUSTA,5
#DEFINE	FS2	ALUSTA,6
#DEFINE	FS3	ALUSTA,7

T0STA		EQU	005H

;	T0STA bits:
#DEFINE	T0PS0	T0STA,1
#DEFINE	T0PS1	T0STA,2
#DEFINE	T0PS2	T0STA,3
#DEFINE	T0PS3	T0STA,4
#DEFINE	T0CS	T0STA,5
#DEFINE	T0SE	T0STA,6
#DEFINE	INTEDG	T0STA,7

CPUSTA		EQU	006H

;	CPUSTA bits:
#DEFINE	BOR	CPUSTA,0
#DEFINE	POR	CPUSTA,1
#DEFINE	NOT_PD	CPUSTA,2
#DEFINE	NOT_TO	CPUSTA,3
#DEFINE	GLINTD	CPUSTA,4
#DEFINE	STKAV	CPUSTA,5

INTSTA		EQU	007H

;	INTSTA bits:
#DEFINE	INTE	INTSTA,0
#DEFINE	T0IE	INTSTA,1
#DEFINE	T0CKIE	INTSTA,2
#DEFINE	PEIE	INTSTA,3
#DEFINE	INTF	INTSTA,4
#DEFINE	T0IF	INTSTA,5
#DEFINE	T0CKIF	INTSTA,6
#DEFINE	PEIF	INTSTA,7

INDF1		EQU	008H
FSR1		EQU	009H
WREG		EQU	00AH
TMR0L		EQU	00BH
TMR0H		EQU	00CH
TBLPTRL		EQU	00DH
TBLPTRH		EQU	00EH
BSR		EQU	00FH

;----- Bank 0 -------------------------------------------------------------

EP1_CFG1	EQU	010H
EP1_CFG2	EQU	011H
EP2_CFG1	EQU	012H
EP2_CFG2	EQU	013H

Block		EQU	006H	; !!!

;----- Bank 1 -------------------------------------------------------------

DESC_ADR	EQU	110H
DESC_DATA	EQU	111H
PORTA		EQU	112H
DDRD		EQU	113H
PORTD		EQU	114H
DDRC		EQU	115H
PORTC		EQU	116H

;----- Bank 2 -------------------------------------------------------------

EP1_REG		EQU	210H
EP2_REG 	EQU	211H
NAND_DATA2	EQU	212H	;  NAND_DATA
CRPT_DATA2 	EQU	213H	;  CRPT_DATA
PIR1		EQU	214H

;	PIR1 bits:
#DEFINE	RCIF	PIR1,0
#DEFINE	TXIF	PIR1,1
#DEFINE	UsbIF	PIR1,2
#DEFINE	NandIF	PIR1,3
#DEFINE	EepromIF	PIR1,4
#DEFINE	CryptoIF	PIR1,5

PIE1		EQU	215H

;	PIE1 bits:
#DEFINE	RCIE	PIE1,0
#DEFINE	TXIE	PIE1,1
#DEFINE	UsbIE	PIE1,2
#DEFINE	NandIE	PIE1,3
#DEFINE	EepromIE	PIE1,4
#DEFINE	CryptoIE	PIE1,5

;----- Bank 3 -------------------------------------------------------------

EP1_STAT	EQU	310H
EP2_STAT	EQU	311H

Empty		EQU	000H	; !!!
Full		EQU	001H	; !!!

EP1_CNT		EQU	314H
EP2_CNT		EQU	315H

;----- Bank 4 -------------------------------------------------------------

USB_ADR		EQU	410H
USB_ERROR	EQU	411H
USB_STAT	EQU	412H
USB_CTRL	EQU	413H
USB_IE1		EQU	414H
USB_IE2		EQU	415H
USB_IE3		EQU	416H
USB_IE4		EQU	417H

;----- Bank 5 -------------------------------------------------------------

DDRE		EQU	511H
PORTE		EQU	512H
RCSTA1		EQU	513H

;	RCSTA1 bits:
#DEFINE	RX9D	RCSTA1,0
#DEFINE	OERR	RCSTA1,1
#DEFINE	FERR	RCSTA1,2
#DEFINE	CREN	RCSTA1,4
#DEFINE	SREN	RCSTA1,5
#DEFINE	RX9	RCSTA1,6
#DEFINE	SPEN	RCSTA1,7

RCREG1		EQU	514H
TXSTA1		EQU	515H

;	TXSTA1 bits:
#DEFINE	TX9D	TXSTA1,0
#DEFINE	TRMT	TXSTA1,1
#DEFINE	SYNC	TXSTA1,4
#DEFINE	TXEN	TXSTA1,5
#DEFINE	TX9	TXSTA1,6
#DEFINE	CSRC	TXSTA1,7

TXREG1		EQU	516H
SPBRG1		EQU	517H

;----- Bank 6 -------------------------------------------------------------

NAND_MODE	EQU	610H
NAND_DATA	EQU	611H
WRDIF		EQU	613H
EEPROM_CONT	EQU	614H
EEPROM_MODE	EQU	615H
EEPROM_DATA	EQU	616H
EEPROM_ADDR	EQU	617H

;----- Bank 7 -------------------------------------------------------------

CRPT_CWR	EQU	710H
CRPT_SR		EQU	711H
CRPT_DATA	EQU	712H
CRPT_KR		EQU	713H
CRPT_CR		EQU	714H
CRPT_SYNR	EQU	715H
CRPT_ITER	EQU	716H
CRPT_IMIT	EQU	717H

;----- Unbanked -----------------------------------------------------------

PRODL		EQU	018H
PRODH		EQU	019H

;--------------------------------------------------------------------------

W		EQU	000H
F		EQU	001H

Bank0		EQU	000H
Bank1		EQU	001H
Bank2		EQU	002H
Bank3		EQU	003H
Bank4		EQU	004H
Bank5		EQU	005H
Bank6		EQU	006H
Bank7		EQU	007H

; ==========================================================================
