;==========================================================================
;		 PASM-MC ()
;==========================================================================

INDF0		EQU	000H
FSR0		EQU	001H
PCL		EQU	002H
PCLATH		EQU	003H
ALUSTA		EQU	004H

;	ALUSTA bits:
 C		EQU	ALUSTA,0
 DC		EQU	ALUSTA,1
 Z		EQU	ALUSTA,2
 OV		EQU	ALUSTA,3
 FS0		EQU	ALUSTA,4
 FS1		EQU	ALUSTA,5
 FS2		EQU	ALUSTA,6
 FS3		EQU	ALUSTA,7

T0STA		EQU	005H

;	T0STA bits:
 T0PS0		EQU	T0STA,1
 T0PS1		EQU	T0STA,2
 T0PS2		EQU	T0STA,3
 T0PS3		EQU	T0STA,4
 T0CS		EQU	T0STA,5
 T0SE		EQU	T0STA,6
 INTEDG		EQU	T0STA,7

CPUSTA		EQU	006H

;	CPUSTA bits:
 BOR		EQU	CPUSTA,0
 POR		EQU	CPUSTA,1
 NOT_PD		EQU	CPUSTA,2
 NOT_TO		EQU	CPUSTA,3
 GLINTD		EQU	CPUSTA,4
 STKAV		EQU	CPUSTA,5

INTSTA		EQU	007H

;	INTSTA bits:
 INTE		EQU	INTSTA,0
 T0IE		EQU	INTSTA,1
 T0CKIE		EQU	INTSTA,2
 PEIE		EQU	INTSTA,3
 INTF		EQU	INTSTA,4
 T0IF		EQU	INTSTA,5
 T0CKIF		EQU	INTSTA,6
 PEIF		EQU	INTSTA,7

INDF1		EQU	008H
FSR1		EQU	009H
WREG		EQU	00AH
TMR0L		EQU	00BH
TMR0H		EQU	00CH
TBLPTRL		EQU	00DH
TBLPTRH		EQU	00EH
BSR		EQU	00FH

;----- Bank 0 -------------------------------------------------------------

EP1_CFG1	EQU	010H
EP1_CFG2	EQU	011H
EP2_CFG1	EQU	012H
EP2_CFG2	EQU	013H
EP3_CFG1	EQU	014H
EP3_CFG2	EQU	015H
EP4_CFG1	EQU	016H
EP4_CFG2	EQU	017H

 Block		EQU	006H	; !!!

;----- Bank 1 -------------------------------------------------------------

DESC_ADR	EQU	110H
DESC_DATA	EQU	111H
PORTA		EQU	112H
DDRD		EQU	113H
PORTD		EQU	114H
DDRC		EQU	115H
PORTC		EQU	116H

;----- Bank 2 -------------------------------------------------------------

EP1_REG		EQU	210H
EP2_REG 	EQU	211H
EP3_REG		EQU	212H
EP4_REG 	EQU	213H
PIR1		EQU	214H

;	PIR1 bits:
 RCIF		EQU	PIR1,0
 TXIF		EQU	PIR1,1
 UsbIF		EQU	PIR1,2
 NandIF		EQU	PIR1,3
 EepromIF	EQU	PIR1,4
 CryptoIF	EQU	PIR1,5

PIE1		EQU	215H

;	PIE1 bits:
 RCIE		EQU	PIE1,0
 TXIE		EQU	PIE1,1
 UsbIE		EQU	PIE1,2
 NandIE		EQU	PIE1,3
 EepromIE	EQU	PIE1,4
 CryptoIE	EQU	PIE1,5

;----- Bank 3 -------------------------------------------------------------

EP1_STAT	EQU	310H
EP2_STAT	EQU	311H
EP3_STAT	EQU	312H
EP4_STAT	EQU	313H

 Empty		EQU	000H	; !!!
 Full		EQU	001H	; !!!

EP1_CNT		EQU	314H
EP2_CNT		EQU	315H
EP3_CNT		EQU	316H
EP4_CNT		EQU	317H

;----- Bank 4 -------------------------------------------------------------

USB_ADR		EQU	410H
USB_ERROR	EQU	411H
USB_STAT	EQU	412H
USB_CTRL	EQU	413H
USB_IE1		EQU	414H
USB_IE2		EQU	415H
USB_IE3		EQU	416H
USB_IE4		EQU	417H

;----- Bank 5 -------------------------------------------------------------

DDRE		EQU	511H
PORTE		EQU	512H
RCSTA1		EQU	513H

;	RCSTA1 bits:
 RX9D		EQU	RCSTA1,0
 OERR		EQU	RCSTA1,1
 FERR		EQU	RCSTA1,2
 CREN		EQU	RCSTA1,4
 SREN		EQU	RCSTA1,5
 RX9		EQU	RCSTA1,6
 SPEN		EQU	RCSTA1,7

RCREG1		EQU	514H
TXSTA1		EQU	515H

;	TXSTA1 bits:
 TX9D		EQU	TXSTA1,0
 TRMT		EQU	TXSTA1,1
 SYNC		EQU	TXSTA1,4
 TXEN		EQU	TXSTA1,5
 TX9		EQU	TXSTA1,6
 CSRC		EQU	TXSTA1,7

TXREG1		EQU	516H
SPBRG1		EQU	517H

;----- Bank 6 -------------------------------------------------------------

NAND_MODE	EQU	610H
NAND_DATA	EQU	611H
WRDIF		EQU	613H
EEPROM_CONT	EQU	614H
EEPROM_MODE	EQU	615H
EEPROM_DATA	EQU	616H
EEPROM_ADDR	EQU	617H

;----- Bank 7 -------------------------------------------------------------

SSPCON1		EQU	711H
;
SSPSTAT		EQU	713H
SSPBUF		EQU	714H

;----- Unbanked -----------------------------------------------------------

PRODL		EQU	018H
PRODH		EQU	019H

;--------------------------------------------------------------------------

W		EQU	000H
F		EQU	001H

Bank0		EQU	000H
Bank1		EQU	001H
Bank2		EQU	002H
Bank3		EQU	003H
Bank4		EQU	004H
Bank5		EQU	005H
Bank6		EQU	006H
Bank7		EQU	007H

; ==========================================================================
