; ******************************************************************************
;		    EVAL9
; ******************************************************************************
;
;  : 18863
;  : 24 
;
; USB :  12 / (Full Speed)
;
; *******************************************************************************
;         :
; RA0 ()   SW3 (  GND)
; RA1,RA2,RA3 ()   
; RC0-RC7 (./.)   D3,   ""=0
; RD0-RD7 (./.)   D3,   ""=0
; RE0 (./.)    ,   ""
; RE1 (./.)    ,   ""
; RE2 (./.)    ,   ""
; RE3 (./.)    ,   ""
; RE4-RE7 (./.)   ,    
; *******************************************************************************
	CHIP	17C756

	Include 1886VE3.INC

;      

BSR_1		EQU     01FH ;    BSR    TMR0
PCLATH_1	EQU     020H ;    PCLATH    TMR0
ALUSTA_1	EQU     021H ;    ALUSTA    TMR0
WREG_1		EQU     022H ;    WREG    TMR0

W0_INT	EQU	024H	;      TMR0
W1_INT	EQU	025H	;     
DataInp	EQU	026H	;  ,   
DataOut	EQU	027H	;   
FLAG	EQU	028H	;  :
	; FLAG,1- =1      
	; FLAG,7- 0/1 -  /  

WORK0   EQU     030H ;   0
WORK1   EQU     031H ;   1
WORK2   EQU     032H ;   2
WORK3   EQU     033H ;   3

; ************************************************************************************
                CODE
                ORG     0000H

Start:  BSF     GLINTD  ; (CPUSTA,GLINTD)   
        CLRF    BSR,F   ;  SFR  GPR Bank 0
        GOTO    Start0
; ************************************************************************************
;		  TMR0

		ORG	0010H

IntTMR0:
	MOVFP   BSR,BSR_1       ;   BSR
        CLRF    BSR,F           ;  SFR  GPR Bank 0
        MOVPF   ALUSTA,ALUSTA_1 ;   ALUSTA
        MOVPF   PCLATH,PCLATH_1 ;   PCLATH
        MOVPF   WREG,WREG_1	;   WREG
	GOTO	INT010

;		  USB

		ORG	0020H
IntUSB:

	GOTO	Start0

; ************************************************************************************

INT010:	BCF	INTSTA,5 ;  T0IF

	MOVLB	Bank5

	MOVLW	0F0h
	MOVWF	DDRE	; PORTE,4-7 - 
	MOVLW	07h
	MOVWF	PORTE

	MOVLW	6
INT012:	DECFSZ	WREG,F
	GOTO	INT012	; 

	MOVLW	0F0h
	ANDWF	PORTE,W	;    
	MOVWF	W0_INT

	MOVLW	0Bh
	MOVWF	PORTE

	MOVLW	6
INT014:	DECFSZ	WREG,F
	GOTO	INT014	; 

	MOVLW	0F0h
	ANDWF	PORTE,W	;    
	SWAPF	WREG,W
	IORWF	W0_INT,W

	CPFSEQ	W1_INT
	GOTO	INT020
	CPFSEQ	DataInp
	BSF	FLAG,1	;     
	MOVPF	WREG,DataInp
INT020:	MOVPF	WREG,W1_INT

	BTG	FLAG,7

	MOVFP	DataOut,WREG
	BTFSS	FLAG,7
	SWAPF	DataOut,W
	IORLW	0Fh
	ANDLW	0FEh
	BTFSC	FLAG,7
	XORLW	03h
	MOVWF	PORTE	;  
	CLRF	DDRE,F

	MOVLB	Bank1
	BTFSS	PORTA,0	;    SW3
	BSF	FLAG,1	;     

	MOVFP   PCLATH_1,PCLATH ;  
        MOVFP   WREG_1,WREG
        MOVFP   ALUSTA_1,ALUSTA
        MOVFP   BSR_1,BSR
        RETFIE

; ************************************************************************************
;		 USB  (128 )
; ************************************************************************************
		ORG	0100h
Descriptor:
	ADDWF	PCL,F

        RETLW   12h	; DEVICE descriptor
        RETLW   01h
        RETLW   00h
        RETLW   10h
        RETLW   0FFh
        RETLW   00h
        RETLW   0FFh
        RETLW   08H
        RETLW   34h
        RETLW   12h
        RETLW   78h
        RETLW   56h
        RETLW   00h
        RETLW   00h

        RETLW   01h	; indexes string desc
        RETLW   02h
        RETLW   03h
        RETLW   01h	; -------------------

        RETLW   09h	; CONFIGURATION descriptor
        RETLW   02h
        RETLW   20h
        RETLW   00h
        RETLW   01h
        RETLW   01h
        RETLW   00h
        RETLW   0C0h
        RETLW   0A0h

        RETLW   09h	; INTERFACE descriptor
        RETLW   04h
        RETLW   00h
        RETLW   00h
        RETLW   02h
        RETLW   0FFh	; int class
        RETLW   01h	; interfeSubClass
        RETLW   0FFh	; int prot
        RETLW   00h

        RETLW   07h	; ENDPOINT 1 descriptor (out)
        RETLW   05h	;      
        RETLW   01h
        RETLW   03h	; 02h
        RETLW   40H
        RETLW   00h
        RETLW   01h

        RETLW   07h	; ENDPOINT 2 descriptor (in)
        RETLW   05h	;      
        RETLW   82h
        RETLW   03h	; 02h
        RETLW   40H
        RETLW   00h
        RETLW   01h

	RETLW   00h	; ENDPOINT 3 and 4 descriptor
	RETLW   00h
	RETLW   00h
	RETLW   00h
	RETLW   00h
	RETLW   00h
	RETLW   00h

	RETLW   00h
	RETLW   00h
	RETLW   00h
	RETLW   00h
	RETLW   00h
	RETLW   00h
	RETLW   00h

	RETLW   08h	; Languages
	RETLW   03h
	RETLW   09h
	RETLW   04h
	RETLW   09h
	RETLW   04h
	RETLW   09h
	RETLW   04h

	RETLW   0Ah	; String 1
	RETLW   03h
	RETLW   01h
	RETLW   02h
	RETLW   03h
	RETLW   04h
	RETLW   05h
	RETLW   06h
	RETLW   07h
	RETLW   08h

	RETLW   0Ah	; String 2
	RETLW   03h
	RETLW   0Ah
	RETLW   0Bh
	RETLW   0CH
	RETLW   0Dh
	RETLW   0Eh
	RETLW   0Fh
	RETLW   10h
	RETLW   11h

	RETLW   0Ah	; String 3
	RETLW   03h
	RETLW   12h
	RETLW   13h
	RETLW   14h
	RETLW   15h
	RETLW   16h
	RETLW   17h
	RETLW   18h
	RETLW   19h	

	RETLW   0Ah	; string 4
	RETLW   03h
	RETLW   1Ah
	RETLW   1Bh
	RETLW   1Ch
	RETLW   1Dh
	RETLW   1Eh
	RETLW   1Fh
	RETLW   20H
	RETLW   21h
	RETLW   22h
	RETLW   23h
	RETLW   24h
	RETLW   25h
	RETLW   26h
	RETLW   27h
	RETLW   28h
	RETLW   29h
	RETLW   2Ah
	RETLW   2Bh
	RETLW   2Ch
	RETLW   2Dh
	RETLW   2Eh
	RETLW   2Fh
	RETLW   30h
	RETLW   31h
; *********************************************************************************
; *********************************************************************************

Start0:

;    (PORTC,D,E)

	MOVLB	Bank5

	CLRF	PORTE,F
	CLRF	DDRE,F	;  E -  =0

        MOVLB   Bank1   ;  SFR  1

        CLRF    PORTC,F
        CLRF    DDRC,F  ;  C -  =0

        CLRF    PORTD,F
        CLRF    DDRD,F  ;  D -  =0

	CALL	USB_ON		;     USB 

;		  USB 

	MOVLB	Bank4

L1210:	CLRWDT
	BTFSS	USB_STAT,5 ;   USB
	GOTO	L1210

	BCF	USB_STAT,4 ;   USB_RST

; USB   -    USB_RST   TMR0

	CLRF	USB_IE1
	MOVLW	80h
	MOVWF	USB_IE2	;  USB_RST_IE
	CLRF	USB_IE3
	MOVLW	08h
	MOVWF	USB_IE4	;  USB_ALL_IE

	MOVLB	Bank2

	CLRF	PIR1	;    
	MOVLW	04h
	MOVWF	PIE1	;  USB_IE

	MOVLW	20h
	MOVWF	T0STA	;  TMR0 (. , 1:1)

	MOVLW	0Ah
	MOVWF	INTSTA	;  PEIE + T0IE

	CLRF	W1_INT,F ;   
	CLRF	FLAG,F
	CLRF	DataInp,F
	CLRF	DataOut,F

	BCF	GLINTD	;  

; ================================================================================
;		     USB
; ================================================================================

L2000:	CLRWDT
	MOVLB	Bank3

	BTFSS	EP1_STAT,Empty	;     FIFO 1
	GOTO	L2015	;  -  FIFO 1  

	BTFSS	FLAG,1	;      
	GOTO	L2000

	BTFSS	EP2_STAT,Empty ;   FIFO 2   
	GOTO	L2000

	MOVLB	Bank2
	MOVFP	DataInp,EP2_REG	;    FIFO 2
	BCF	FLAG,1	;      
	GOTO	L2000

L2015:	MOVLB	Bank2
	MOVPF	EP1_REG,DataOut	;   
	GOTO	L2000

; ===================================================================================
;		    USB 
; ===================================================================================
USB_ON:
	MOVLB	Bank1

	CLRF	WORK0,F
L110:	MOVFP	WORK0,DESC_ADR	;   
	MOVFP	WORK0,WREG
	CALL	Descriptor
	MOVFP	WREG,DESC_DATA	;   
	INCF	WORK0,F
	BTFSS	WORK0,7		;  128 
	GOTO	L110

;  USB

	MOVLB	Bank0
	MOVLW	40h
	MOVWF	EP1_CFG1	;     
	MOVWF	EP2_CFG1

	MOVLW	04h	; 24h
	MOVWF	EP1_CFG2 ; ENDPOINT 1: OUT,Interrupt Transfer(   )
	MOVLW	02h	; 22h
	MOVWF	EP2_CFG2 ; ENDPOINT 2: IN,Interrupt Transfer(   )

	MOVLB	Bank4

	MOVLW	03h
	MOVWF	USB_CTRL	; .USB,  "Full speed"

	RETURN

; **********************************************************************************

        END
